clc
clear all
close all

tic

parameters


warning off
% %

% Defining Initial inputs (for the first time step)
Q1_0=147250;
Q2_0=21185;
P2_0=20000;
Valve_0=70;

u0=[Q1_0 Q2_0 P2_0 Valve_0];
u=u0;

SC = [200000 100000 50000 100]; %Scaling values

usc0 = u0./SC; %scaling the guessed inputs

P1_duty = 4.5403e+06;
ksi = 0.3886;




% Initial state for Simulink model

initialstate





%%% OPTIMIZER%%%%

 

    
      a=[];
    b=[];
   
    Aeq=[];
    beq=[];
    
%%%%%For unscaled optimization
%     LB_1=0;      % Lower boundry of Q_invested_1 
%     UB_1= Inf;   % No upper boundry
%     LB_2=0;      % Lower boundry of Q_invested_2 
%     UB_2= Inf;   % No upper boundry
%     LB_3=0;      % P2_duty
%     UB_3= Inf;   % P2_duty No upper boundry
%     LB_4=0;      % Almost closed Valve 
%     UB_4=100;    % Fully open valve


%%%%For scaled optimization
    LB_1=0.01;      % Lower boundry of Q_invested_1 
    UB_1= 1;   % No upper boundry
    LB_2=0.01;      % Lower boundry of Q_invested_2 
    UB_2= 1;   % No upper boundry
    LB_3=0.01;      % P2_duty
    UB_3= 1;   % P2_duty No upper boundry
    LB_4=0.01;      % Almost closed Valve 
    UB_4=1;    % Fully open valve

    
    
    LB = [LB_1 LB_2 LB_3 LB_4];
    UB = [UB_1 UB_2 UB_3 UB_4];
    
    
    %[u,objval,EXITFLAG,OUTPUT,LAMBDA,GRAD,Hessian]=fmincon('optimizer',u,a,b,Aeq,beq,LB,UB);  %For unscaled optimization
    
    [usc, objval,EXITFLAG,OUTPUT,LAMBDA,GRAD,Hessian]=fmincon('optimizer',usc0,a,b,Aeq,beq,LB,UB); %%For scaled optimization
    
    u = usc.*SC;

   
    % Run the model - as the real plant
    
    
    time=0;
    tstep=Ts*3;


    uext=[time u0; time+tstep u];
    
    options=simset('InitialState',InitialState,'FinalStateName','FinalState');
    
    [T,x,y] = sim('proba53_MPC_test_2ny2',[time time+tstep],options,uext);
    
 
 
    toc
    